function getLogger (logger, level, mode) {
    var logError, logWarning, logInfo, logDebug;
    if (level === 'ERROR') {
        logError = true;
        logWarning = false;
        logInfo = false;
        logDebug = false;
    } else if (level === 'WARNING') {
        logError = true;
        logWarning = true;
        logInfo = false;
        logDebug = false;
    } else if (level === 'INFO') {
        logError = true;
        logWarning = true;
        logInfo = true;
        logDebug = false;
    } else if (level === 'DEBUG') {
        logError = true;
        logWarning = true;
        logInfo = true;
        logDebug = true;
    } else {
        logError = true;
        logWarning = false;
        logInfo = false;
        logDebug = false;
    }

    var loggerInstance = null;
    if(mode!=="extended"){
        loggerInstance = {
            error: function (msg) {
                if (logError) {
                    logger('ERROR: ' + msg);
                }
            },
            warning: function (msg) {
                if (logWarning) {
                    logger('WARNING: ' + msg);
                }
            },
            info: function (msg) {
                if (logInfo) {
                    logger('INFO: ' + msg);
                }
            },
            debug: function (msg) {
                if (logDebug) {
                    logger('DEBUG: ' + msg);
                }
            }
        };
    } else {
        loggerInstance = {
            error: function (tag, message, object) {
                if (logError) {
                    logger('ERROR', tag, message, object);
                }
            },
            warning: function (tag, message, object) {
                if (logWarning) {
                    logger('WARNING', tag, message, object);
                }
            },
            info: function (tag, message, object) {
                if (logInfo) {
                    logger('INFO', tag, message, object);
                }
            },
            debug: function (tag, message, object) {
                if (logDebug) {
                    logger('DEBUG', tag, message, object);
                }
            }
        };
    }
    return loggerInstance;
}
var consoleLogger = function (msg) {
    //console.log(msg);
    //window.appLogs.push(msg);    
};

var extendedConsoleLogger = function (level, tag, message, object) {
    if(object!==undefined){
        var logObject = Object.assign({}, object);
        //console.log(level, tag, message, logObject);
    } else {
        //console.log(level, tag, message);
    }
    //window.appLogs.push({level, tag, message, object});
};

var alertLogger = function (msg) {
    //alert(msg);
};

var debugLogger = getLogger(consoleLogger, 'DEBUG');
var extendedDebugLogger = getLogger(extendedConsoleLogger, 'DEBUG', 'extended');

export {debugLogger, extendedDebugLogger, getLogger, consoleLogger, alertLogger};
