export default class Route {
    constructor(url){
        this.url = document.createElement('a');
        this.url.href = url;
    }
    getFullRoute(){
        return this.url.href;
    }
    getFullPathnameAndSearchAndHashParams (){
        return this.url.pathname + this.url.search + this.url.hash;
    }
    getHost(){
        return this.url.host;
    }
    getHostname(){
        return this.url.hostname;
    }
    getPathname(){
        return this.url.pathname;
    }
    getRoute(){
        return this.url();
    }
    getProtocol(){
        return this.url.protocol;
    }
    getSearchString(){
        return this.url.search;
    }
    getUrl(){
        return this.url;
    }
    setRoute(url){
        this.url.href = url;
    }
    setHostname(hostname){
        this.url.hostname = hostname;
    }
    isAppLandingPage(){
        return (this.url.href.indexOf('/app.html') > -1); // If > -1: Page is app.html
    }
    isDomainWithoutSubdomain (){
        var domains = ["https://cyberport.de","https://www.cyberport.de","https://cyberport.at","https://www.cyberport.at"];
        var result = (this.url.href.indexOf(domains) !== -1 ? true : false);
        return result;
    }
    isDirectoryRoot (){
        var result = (this.url.pathname === "/" ? true : false);
        return result;
    }
    isPathPdpDeeplink (){
        return (this.url.href.indexOf("?DEEP") !== -1 ? true : false );
    }
    isNewsletterLink (){
        return (this.url.href.indexOf("mail.cyberport.de") !== -1 ||
                this.url.href.indexOf("mail.cyberport.at") !== -1 ? true : false );
    }
    isPathAppStartpage (){
        var result = null;
        if(this.url.href.indexOf("/content/webshop30_de/de.html") !== -1 ||
            this.url.href.indexOf("/content/webshop30_at/de.html") !== -1){
            result = true;
        } else {
            result = false;
        }
        return result;
    }

}
