import DeviceDetails from "../util/deviceDetails";
import Constants from "../constants";

/**
 * Function checks if opened URL is feedback form. If feedback form page is opened, function fills form with device and os information.
 */
export function initFeedbackFormPage() {
    var currentUrl = window.location.href;
    if (currentUrl.indexOf('feedback-zur-app.html') > -1) {          // -1 never occurs, 1 exists
        // Set device_name = Name des Gerätes (bspw. iPhone 6s)
        $("input[name='device_name']").val(device.manufacturer + " " + device.model);

        // Set os_version = Name und Version der Betriebssystems (bspw. iOS 10.3.3)
        $("input[name='os_version']").val(device.platform + " " + device.version);

        // Set app_version = Name der App Version (bspw. iOS-App 0.1.2)
        if (DeviceDetails.isAndroid()) {
            $("input[name='app_version']").val(Constants.appVersionAndroid);
        } else if (DeviceDetails.isIos()) {
            $("input[name='app_version']").val(Constants.appVersionIos);
        } else {
            $("input[name='app_version']").val("App-Platform nicht erkannt! (" + Constants.appVersionAndroid + " oder " + Constants.appVersionIos + ")");
        }
    }
}
