import DeviceDetails from "../util/deviceDetails";
import Constants from "../constants";
import AdjustHandler from "../util/adjustHandler";
import {extendedDebugLogger as logExtended} from "../logger/log";

/**
 * Sends the Adjust purchase tracking event when order confirmation page in new checkout is shown
 */
export function initOrderConfirmationPageNewCheckout() {
    try{
        // new confirmation site: checkout/confirmation.html
        // old confirmation site: tools/checkout.success.html
        const netRevenue = window.dataLayer.transaction.netRevenue; // (articleprice+shippingcosts) excl. TAX
        const grossRevenue = window.dataLayer.transaction.grossRevenue; // (articleprice+shippingcosts) incl. TAX
        AdjustHandler.trackPurchaseEvent(netRevenue)

    } catch(ex){
        logExtended.error(
            'initOrderConfirmationPageNewCheckout ',
            'Could not init initOrderConfirmationPageNewCheckout',
            {
                "err": Object.assign({}, ex),
            });
    }
}
