import {Router} from "./router";
import DeviceDetails from "./deviceDetails";

var Backbutton = (function () {
    /**
     * Function shows non-native back button in iOS
     */
    function showBackButtonIos() {
        var backButton = document.getElementById("appHistoryBack");
        var logo = document.querySelector(".cpHeaderLogo");
        var referrer = document.referrer;
        var currentUrl = window.location.href;
        var historyLength = window.history.length;
        if (referrer && backButton) {
            if (!Router.isAppLandingPage(referrer) && DeviceDetails.isIos() && !((historyLength<2) && (referrer === currentUrl))) {
                backButton.addEventListener("click", function(){
                    window.history.back();
                });
                backButton.classList.remove("showInApp");
                backButton.classList.add("is--active");
                if(logo){
                    logo.classList.add("isArrowVisible");
                }
            }
        }
    }

    // ++++++++++++++++++++++++++++++++ Public methods ++++++++++++++++++++++++++++++++
    return {
        showBackButtonIos
    };
})();
export {Backbutton};
