import {debugLogger as log} from '../logger/log';
import {ProductsToShareDialog} from './productsToShareDialog';
import {handleInappBrowserClick} from './openExternalLinksInAppBrowser';

/**
 * Intercepts all onclick events on the body and may act on the following cases:
 *
 * Use case 1:
 * Clicks on mailto:// links are forwarded to the native share dialog.
 *
 * Use case 2:
 * Some links should be opened in the inappbrowser. Those links are "blacklisted" from opening in the webview
 * and are opened in the inappbrowser.
 */
function globalHrefClickHandler(){
    document.body.onclick = function(e){
        e = e || event;
        log.debug("globalCordovaLinkClickHandler onclick");
        log.debug(e);
        var el = $(e.target).closest("a"); //todo: findet nix???
        
        if(typeof el !=="undefined" && el.length>0){
            /** Click on product share dialog links to open in native share dialog **/
            var href = $(el[0]).attr("href"); 
            if(href!=null){
                if(href.indexOf("mailto")!==-1){
                    ProductsToShareDialog.handleClick(e, el[0].href);
                } 
                /** Click on dpd/dhl links to open in inappbrowser  **/
                handleInappBrowserClick(e, href);
            }
        }
    }
}
export {globalHrefClickHandler};
