import UserDetails from "./userDetails";

let testUtils = {
    initSettingsFromCommandline: function(settings){
        UserDetails.updateAppSettings(settings, function (err, res) {
            if (res) {
                console.log("success", res);
            } else {
                console.log("err", err);
            }
        });
    },

    initEmptySettings: function(){
        let settingsObj = {
            selectedShop : 'de',
            autoLogin: true,
            fingerprintLogin: false,
            fingerprintLoginDecision: '',
            credentials : {
                username: '',
                password: '',
                valid: false
            },
            lastStartup: 0,
            autoLoginTimeout: 30,
            preventAutoLoginForLoggedOutUser: false,
            countForSessionTimeoutMessage: 0,            // Session Timeout Message is shown, when value = 1
            showDialogAskForFingerprintDecision: true
        };

        UserDetails.updateAppSettings(settingsObj, function (err, res) {
            if (res) {
                console.log("success", res);
            } else {
                console.log("err", err);
            }
        });
    },

    initValidAutologinSettings: function(){
        const lastStartup = new Date();
        lastStartup.setDate(lastStartup.getDate()-5); // -5 days

        let appSettingsEmpty = {
            selectedShop : 'de',
            autoLogin: true,
            fingerprintLogin: true,
            fingerprintLoginDecision: '',
            credentials : {
                username: 'cp_app_stg_b2c@byom.de',
                password: 'AppSTGcyberport12!',
                valid: true
            },
            lastStartup: lastStartup.getTime(),
            autoLoginTimeout: 30,
            preventAutoLoginForLoggedOutUser: false,
            countForSessionTimeoutMessage: 0,            // Session Timeout Message is shown, when value = 1
            showDialogAskForFingerprintDecision: false
        };
        UserDetails.updateAppSettings(settings, function (err, res) {
            if (res) {
                console.log("success", res, JSON.stringify(res));
            } else {
                console.log("err", err);
            }
        });
    },

    initValidAutologinSettingsWithTimeout: function(){
        const lastStartup = new Date();
        lastStartup.setDate(lastStartup.getDate()-30); // -30 days

        let appSettings = {
            selectedShop : 'de',
            autoLogin: true,
            fingerprintLogin: true,
            fingerprintLoginDecision: 'yes',
            credentials : {
                username: 'cp_app_stg_b2c@byom.de',
                password: 'AppSTGcyberport12!',
                valid: true
            },
            lastStartup: lastStartup.getTime(),
            autoLoginTimeout: 30,
            preventAutoLoginForLoggedOutUser: false,
            countForSessionTimeoutMessage: 0,            // Session Timeout Message is shown, when value = 1
            showDialogAskForFingerprintDecision: false
        };
        UserDetails.updateAppSettings(appSettings, function (err, res) {
            if (res) {
                console.log("success", res, JSON.stringify(res));
            } else {
                console.log("err", err);
            }
        });
    },

    getCurrentAppSettings: function(){
        UserDetails.getAppSettings(function (err, res) {
            if (res) {
                console.log("success", res, JSON.stringify(
                    {
                            loggedIn: UserDetails.isUserLoggedIn(),
                            res: res
                    }));
            } else {
                console.log("err", err);
            }
        });
    }
}

export {testUtils};
