import {debugLogger as log} from '../logger/log';

/**
 * Initializes the object window.cpApp
 * This is used for interaction between the APP-JS and WS-JS.
 * Use cases:
 * 1) App-JS registers its presence for WS-JS (C2 _blank)
 * 2) App-JS offers methods for Adjust tracking to the WS-JS in adjustHandler.js
 */
export default class WindowHandler {
    static init() {
        if(typeof(window.cpApp)=="undefined"){
            window.cpApp = {};
        }
        this.registerAppToWs();
    }

    static registerAppToWs() {
        window.cpApp.registered = true;
    }
}
